//
//  ViewController.m
//  SimpleCalculator
//
//  Created by Peter Hauke on 02.10.13.
//  Copyright (c) 2013 2sox. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
@property (strong) Calculator *myCalculator;
@end

@implementation ViewController

- (IBAction)pushAdd:(UIButton *)sender {
    [self doAddInputValues];
}

-(void)doAddInputValues {
    
    // remember just barely good enough code!
    // ready for refactor & re-test
    
    // getting user input
    NSString *firstString = self.firstNumberField.text;
    NSString *secondString = self.secondNumberField.text;
    
    // check if input is numeric
    NSNumber *firstNumber  = nil;
    NSNumber *secondNumber = nil;
    
    if ([[NSScanner scannerWithString:firstString] scanFloat:NULL]) {
        firstNumber = @(firstString.floatValue);
    }
    if ([[NSScanner scannerWithString:secondString] scanFloat:NULL]) {
        secondNumber = @(secondString.floatValue);
    }
    
    // returns nil if one or both input values are nil (i.e. not numeric)
    NSNumber *resultNumber = [self.myCalculator addNumber:firstNumber
                                               toNumber:secondNumber];
    
    // if resultNumber is nil, show "Not a number" to user
    NSString *result = nil;
    if (!resultNumber) {
        result = @"NaN";
    }  else {
        result = resultNumber.stringValue;
    }
    
    // update UI
    self.resultLabel.text = result;
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField {
    [textField resignFirstResponder];
    return YES;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
	self.myCalculator = [[Calculator alloc] init];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

@end
