//
//  TicTacToeDatabase_Tests.m
//  TicTacToe
//
//  Created by Ingo Kasprzak on 03.10.13.
//  Copyright (c) 2013 Silutions. All rights reserved.
//

@import XCTest;
#import "Game+Methods.h"
#import "Move+Methods.h"

@interface TicTacToeDatabase_Tests : XCTestCase

@end

@implementation TicTacToeDatabase_Tests

- (void)setUp {
    [super setUp];
    // Put setup code here; it will be run once, before the first test case.
}

- (void)tearDown {
    // Put teardown code here; it will be run once, after the last test case.
    [super tearDown];
}

- (void)testNewGame {
	// Create new game object, test consistency of attributes
	TicTacToeDatabase *database = [TicTacToeDatabase sharedTicTacToeDatabase];
	
	Game *game = [database newGame];
	XCTAssertNotNil(game, @"New Game should never be nil!");
	
	XCTAssertNotNil(game.creationDate, @"game.creationDate has to be set!");
	XCTAssertNotNil(game.modificationDate, @"game.modificationDate has to be set!");
	XCTAssertNotNil(game.uid, @"uid has to be set!");
	
	XCTAssertTrue([game winningCombo].count==0, @"There should be no winning combos!");
	
	[database.managedObjectContext deleteObject:game];
}

- (void)testNewMoveForActiveGame {
	// Create new move object, test consistency of attributes

	TicTacToeDatabase *database = [TicTacToeDatabase sharedTicTacToeDatabase];
	
	Game *game = [database newGame];

	Move *move = [database newMoveForActiveGame];
	XCTAssertNotNil(move, @"New move should never be nil!");
	
	XCTAssertNotNil(move.creationDate, @"game.creationDate has to be set!");
	XCTAssertNotNil(move.modificationDate, @"game.modificationDate has to be set!");
	XCTAssertNotNil(move.uid, @"uid has to be set!");
	XCTAssertNotNil(move.game, @"game has to be set!");
	XCTAssertNil(move.field, @"field has to be nil!");
	XCTAssertNotNil(move.player, @"player has to be set!");
	[database.managedObjectContext deleteObject:game];
}



@end
